\section{Control Subsystem}

This section describes in detail the controller designed in order to perform
the task described in \autoref{sec:task}.

\input{content/control-subsystem/data-structures}

\subsection{Finite State Machine}
One can find in this subsection the definition of the finite state automaton
governing the control subsystem. The structure of the different states is
illustrated by \autoref{fig:control-FSM} in an intuitive way, showing the
necessary conditions to move from one state to another while
\autoref{fig:control-FSM-formal} is a shows it in formal way (a simple graph
where the nodes represent behaviours and arcs are labelled by predicates
representing initial conditions of behaviour execution).
\autoref{table:state-behaviour} defines the behaviours associated to each state
and their possible successors with the initial and terminal conditions. Each
behaviour is described in detail in \autoref{subsec:behaviours}.

Terminal conditions are stated in mathematical terms in
\autoref{table:control-terminal}, while it is assumed no error condition is
necessary, as described in \autoref{table:control-error}. It is easy to observe
that the initial conditions stated mathematical terms in
\autoref{table:control-initial} satisfy the \emph{Separability} and
\emph{Internality} conditions. The mathematical expressions refer to variables
defined in \autoref{subsec:data-structures}.

\begin{figure}
    \centering
    \input{content/control-subsystem/control-FSM.tikz}
    \caption{Control subsystem Finite State Machine description}
    \label{fig:control-FSM}
\end{figure}

\begin{figure}
    \centering
    \input{content/control-subsystem/control-FSM-formal.tikz}
    \caption{Control subsystem Finite State Machine structure}
    \label{fig:control-FSM-formal}
\end{figure}

\begin{table}
\centering
\begin{tabular}{| c | c | c | p{0.32\linewidth} || c | c |}
    \hline
    \multicolumn{4}{| c ||}{\textbf{Current State}} &
        \multicolumn{2}{c |}{\textbf{Next State}}\\
    \hline
    \textbf{State} & \textbf{Terminal/Error Cond.} & \textbf{Behaviour} &
    \textbf{Description} & \textbf{Initial Cond.} & \textbf{State} \\
    \hline\hline
    $\leftidx{^c}{\mathcal{S}}{_{1,1}}$ & $\leftidx{^c}{f}{^\tau_{1,1}}=TRUE$ &
        $\leftidx{^c}{\mathcal{B}}{_{1,1}}$ & Move to initial configuration &
        $\leftidx{^c}{f}{^\sigma_{1,2}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,2}}$ \\
    \hline
    $\leftidx{^c}{\mathcal{S}}{_{1,2}}$ & $\leftidx{^c}{f}{^\tau_{1,2}}=TRUE$ &
        $\leftidx{^c}{\mathcal{B}}{_{1,2}}$ & Recognize objects on the scene &
        $\leftidx{^c}{f}{^\sigma_{1,3}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,3}}$ \\
    \hline
    $\leftidx{^c}{\mathcal{S}}{_{1,3}}$ & $\leftidx{^c}{f}{^\tau_{1,3}}=TRUE$ &
        $\leftidx{^c}{\mathcal{B}}{_{1,3}}$ & Generate \emph{Pick} parameters &
        $\leftidx{^c}{f}{^\sigma_{1,4}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,4}}$ \\
    \hline
    \multirow{2}{*}{$\leftidx{^c}{\mathcal{S}}{_{1,4}}$} & 
        \multirow{2}{*}{$\leftidx{^c}{f}{^\tau_{1,4}}=TRUE$} &
        \multirow{2}{*}{$\leftidx{^c}{\mathcal{B}}{_{1,4}}$} & 
        \multirow{2}{*}{Move to \emph{pre-pick} while tracking target} &
        $\leftidx{^c}{f}{^\sigma_{1,4,5}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,5}}$ \\
    \cline{5-6}
    & & & & $\leftidx{^c}{f}{^\sigma_{1,4,1}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,1}}$ \\
    \hline
    $\leftidx{^c}{\mathcal{S}}{_{1,5}}$ & $\leftidx{^c}{f}{^\tau_{1,5}}=TRUE$ &
        $\leftidx{^c}{\mathcal{B}}{_{1,5}}$ & Move to \emph{pick} while
        tracking target & $\leftidx{^c}{f}{^\sigma_{1,6}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,6}}$ \\
    \hline
    $\leftidx{^c}{\mathcal{S}}{_{1,6}}$ & $\leftidx{^c}{f}{^\tau_{1,6}}=TRUE$ &
        $\leftidx{^c}{\mathcal{B}}{_{1,6}}$ & Close the gripper while moving
        with the target & $\leftidx{^c}{f}{^\sigma_{1,7}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,7}}$ \\
    \hline
    $\leftidx{^c}{\mathcal{S}}{_{1,7}}$ & $\leftidx{^c}{f}{^\tau_{1,7}}=TRUE$ &
        $\leftidx{^c}{\mathcal{B}}{_{1,7}}$ & Generate \emph{post-pick}
        parameters & $\leftidx{^c}{f}{^\sigma_{1,8}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,8}}$ \\
    \hline
    $\leftidx{^c}{\mathcal{S}}{_{1,8}}$ & $\leftidx{^c}{f}{^\tau_{1,8}}=TRUE$ &
        $\leftidx{^c}{\mathcal{B}}{_{1,8}}$ & Retract to \emph{post-pick} &
        $\leftidx{^c}{f}{^\sigma_{1,9}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,9}}$ \\
    \hline
    $\leftidx{^c}{\mathcal{S}}{_{1,9}}$ & $\leftidx{^c}{f}{^\tau_{1,9}}=TRUE$ &
        $\leftidx{^c}{\mathcal{B}}{_{1,9}}$ & Generate \emph{Place} parameters&
        $\leftidx{^c}{f}{^\sigma_{1,10}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,10}}$ \\
    \hline
    $\leftidx{^c}{\mathcal{S}}{_{1,10}}$ & $\leftidx{^c}{f}{^\tau_{1,10}}=TRUE$ &
        $\leftidx{^c}{\mathcal{B}}{_{1,10}}$ & Move to \emph{pre-place} &
        $\leftidx{^c}{f}{^\sigma_{1,11}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,11}}$ \\
    \hline
    $\leftidx{^c}{\mathcal{S}}{_{1,11}}$ & $\leftidx{^c}{f}{^\tau_{1,11}}=TRUE$ &
        $\leftidx{^c}{\mathcal{B}}{_{1,11}}$ & Move to \emph{place} &
        $\leftidx{^c}{f}{^\sigma_{1,12}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,12}}$ \\
    \hline
    $\leftidx{^c}{\mathcal{S}}{_{1,12}}$ & $\leftidx{^c}{f}{^\tau_{1,12}}=TRUE$ &
        $\leftidx{^c}{\mathcal{B}}{_{1,12}}$ & Open the gripper &
        $\leftidx{^c}{f}{^\sigma_{1,13}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,13}}$ \\
    \hline
    $\leftidx{^c}{\mathcal{S}}{_{1,13}}$ & $\leftidx{^c}{f}{^\tau_{1,13}}=TRUE$ &
        $\leftidx{^c}{\mathcal{B}}{_{1,8}}$ & Retract to \emph{pre-place} &
        $\leftidx{^c}{f}{^\sigma_{1,1}}=TRUE$ &
        $\leftidx{^c}{\mathcal{S}}{_{1,1}}$ \\
    \hline
\end{tabular}
\caption{Control subsystem states and behaviours correspondences}
\label{table:state-behaviour}
\end{table}

\begin{table}
\centering
\begin{tabular}{l   l}
Behaviour error conditions & 
    $\leftidx{^c}{f}{^\varepsilon_{1,l}} \triangleq \text{FALSE} \quad 
    l = 1,...,13$ \\
\end{tabular}
\caption{Control subsystem behaviours' error conditions}
\label{table:control-error}
\end{table}

\begin{table}
\centering
\begin{tabular}{c | c}
Sets of next states & Initial conditions \\
\hline
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,1}} =
    \left\{\leftidx{^c}{S}{_{1,2}}\right\}$ & $\leftidx{^c}{f}{^\sigma_{1,1}}
    \triangleq \text{TRUE}$ \\
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,2}} =
    \left\{\leftidx{^c}{S}{_{1,3}}\right\}$ & $\leftidx{^c}{f}{^\sigma_{1,2}}
    \triangleq \text{TRUE}$ \\
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,3}} =
    \left\{\leftidx{^c}{S}{_{1,4}}\right\}$ & $\leftidx{^c}{f}{^\sigma_{1,3}}
    \triangleq \text{TRUE}$ \\
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,4}} = \left\{\leftidx{^c}{S}{_{1,1}},
    \leftidx{^c}{S}{_{1,5}}\right\}$ & \begin{tabular}{l}
    $\leftidx{^c}{f}{^\sigma_{1,4,1}}\left(\leftidx{^T_x}{c}{_{1,p}}\right)
    \triangleq \lnot a$ \\
        $\leftidx{^c}{f}{^\sigma_{1,4,5}}\left(\leftidx{^T_x}{c}{_{1,p}}\right)
        \triangleq a$ \\
    \end{tabular} \\
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,5}} =
    \left\{\leftidx{^c}{S}{_{1,6}}\right\}$ & $\leftidx{^c}{f}{^\sigma_{1,5}}
    \triangleq \text{TRUE}$ \\
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,6}} =
    \left\{\leftidx{^c}{S}{_{1,7}}\right\}$ & $\leftidx{^c}{f}{^\sigma_{1,6}}
    \triangleq \text{TRUE}$ \\
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,7}} =
    \left\{\leftidx{^c}{S}{_{1,8}}\right\}$ & $\leftidx{^c}{f}{^\sigma_{1,7}}
    \triangleq \text{TRUE}$ \\
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,8}} =
    \left\{\leftidx{^c}{S}{_{1,9}}\right\}$ & $\leftidx{^c}{f}{^\sigma_{1,8}}
    \triangleq \text{TRUE}$ \\
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,9}} =
    \left\{\leftidx{^c}{S}{_{1,10}}\right\}$ & $\leftidx{^c}{f}{^\sigma_{1,9}}
    \triangleq \text{TRUE}$ \\
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,10}} =
    \left\{\leftidx{^c}{S}{_{1,11}}\right\}$ & $\leftidx{^c}{f}{^\sigma_{1,10}}
    \triangleq \text{TRUE}$ \\
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,11}} =
    \left\{\leftidx{^c}{S}{_{1,12}}\right\}$ & $\leftidx{^c}{f}{^\sigma_{1,11}}
    \triangleq \text{TRUE}$ \\
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,12}} =
    \left\{\leftidx{^c}{S}{_{1,13}}\right\}$ & $\leftidx{^c}{f}{^\sigma_{1,12}}
    \triangleq \text{TRUE}$ \\
$\leftidx{^c}{\hat{\mathcal{S}}}{_{1,13}} =
    \left\{\leftidx{^c}{S}{_{1,1}}\right\}$ & $\leftidx{^c}{f}{^\sigma_{1,13}}
    \triangleq \text{TRUE}$ \\
\end{tabular}
\caption{Control subsystem states' sets of next states and initial conditions}
\label{table:control-initial}
\end{table}

\begin{table}
\centering
\begin{tabular}{rcl}
$\leftidx{^c}{f}{^\tau_{1,1}}$ & $\triangleq $ & $\left(\leftidx{^B_E}{T}{_c}
    = \leftidx{^B_{E_s}}{T}{_d}\right) \land \left(d_c = d_m\right)$\\
$\leftidx{^c}{f}{^\tau_{1,2}}$ & $\triangleq $ &
    $\left(\leftidx{^c}{c}{_1}\left[\leftidx{^B_{1..V}}{O}{_c}\right] \neq
    \text{NIL}\right) \land a$\\
$\leftidx{^c}{f}{^\tau_{1,3}}$ & $\triangleq $ & TRUE\\
$\leftidx{^c}{f}{^\tau_{1,4}}$ & $\triangleq $ & $\left(||\leftidx{^B_E}{T}{_c}
    - \leftidx{^B_{E_a}}{T}{_d}|| < tolerance\right) \lor \lnot a$\\
$\leftidx{^c}{f}{^\tau_{1,5}}$ & $\triangleq $ &
    $\left(\leftidx{^B_E}{T}{_c} = \leftidx{^B_{E_t}}{T}{_d}\right) \lor
    \left(\leftidx{^E_z}{F}{_c} > 0 \right)$\\
$\leftidx{^c}{f}{^\tau_{1,6}}$ & $\triangleq $ & $\left(d_c = d_o\right) \lor
    \left(c_c \geq c_l\right)$\\
$\leftidx{^c}{f}{^\tau_{1,7}}$ & $\triangleq $ & TRUE\\
$\leftidx{^c}{f}{^\tau_{1,8}}$ & $\triangleq $ & $\left(\leftidx{^B_E}{T}{_c}
    = \leftidx{^B_{E_a}}{T}{_d}\right)$\\
$\leftidx{^c}{f}{^\tau_{1,9}}$ & $\triangleq $ & TRUE\\
$\leftidx{^c}{f}{^\tau_{1,10}}$ & $\triangleq $ & $\left(\leftidx{^B_E}{T}{_c}
    = \leftidx{^B_{E_a}}{T}{_d}\right)$\\
$\leftidx{^c}{f}{^\tau_{1,11}}$ & $\triangleq $ &
    $\leftidx{^c}{f}{^\tau_{1,5}}$\\
$\leftidx{^c}{f}{^\tau_{1,12}}$ & $\triangleq $ & $\left(d_c = d_m\right)$\\
$\leftidx{^c}{f}{^\tau_{1,13}}$ & $\triangleq $ & 
    $\leftidx{^c}{f}{^\tau_{1,8}}$\\
\end{tabular}
\caption{Control subsystem behaviours' terminal conditions}
\label{table:control-terminal}
\end{table}

\clearpage
\subsection{Behaviours}
\label{subsec:behaviours}

This subsection defines the transition functions governing the behaviours of
the control system. Stated in mathematical terms which refer to the variables
described in \autoref{subsec:data-structures}.

\paragraph{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,1}}$} Move to the initial
pose and open the gripper in order to avoid delays while picking an object.
Ignore camera readings. This behaviour will terminate once the initial pose is
reached and the gripper is open as defined in \autoref{table:control-terminal}.

\begin{table}[H]
\centering
\begin{tabular}{rl}
General form & $\leftidx{^c}{\mathcal{B}}{_{1,1}} \triangleq 
    \leftidx{^c}{\mathcal{B}}{_{1,1}}\left(\leftidx{^{c,e}}{f}{_{1,1}}, 
    \leftidx{^c}{f}{^\tau_{1,1}}, \leftidx{^c}{f}{^\varepsilon_{1,1}}
    \right)$\\
\hline
Transition function & $\left[\leftidx{^e_y}{c}{^{i+1}_{1,m}},
    \leftidx{^e_y}{c}{^{i+1}_{1,g}}\right]
    :=\leftidx{^{c,e}}{f}{_{1,1}}\left(\leftidx{^c}{c}{^i_1}\right) \triangleq
    \begin{cases} 
        \leftidx{^{c,e}}{f}{_{1,1,1}}\left(\leftidx{^c}{c}{^i_1}\right) \\ 
        \leftidx{^{c,e}}{f}{_{1,1,2}}\left(\leftidx{^c}{c}{^i_1}\right) \\ 
    \end{cases}$ \\
Partial transition functions &
    $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[\leftidx{^B_E}{T}{_d}]
    :=\leftidx{^{c,e}}{f}{_{1,1,1}}\left(\leftidx{^c}{c}{^i_1}\right)
    \triangleq \leftidx{^B_{E_s}}{T}{_d}$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,g}}[d_d]
    :=\leftidx{^{c,e}}{f}{_{1,1,2}}\left(\leftidx{^c}{c}{^i_1}\right)
    \triangleq d_m$\\
\end{tabular}
\caption{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,1}}$ general form and
    transition functions}
\label{table:B1}
\end{table}

\paragraph{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,2}}$} Consume the camera
buffer and update the verified objects hypotheses set. This behaviour will
terminate once a verified object hypotheses is found while the system is active
(Which is controlled by variable $a$ as defined in
\autoref{table:communication-buffers}). This behaviour acts as an \emph{idle}
stage while the system is not active tracking the objects with the Kinect
sensor until the system is activated externally.

\autoref{sec:effectors-and-receptors} explains that the object verification
logic lies inside the Kinect virtual receptor and takes into account the
requirements defined in \autoref{itm:task-conditions} as well as to verify that
objects are located in within the manipulator reach. Therefore the fact that
this behaviour terminates does not only mean that the Kinect sensor has located
an object but that the manipulator should be able to pick it.

\begin{table}[H]
\centering
\begin{tabular}{rl}
General form & $\leftidx{^c}{\mathcal{B}}{_{1,2}} \triangleq 
    \leftidx{^c}{\mathcal{B}}{_{1,2}}\left(\leftidx{^{c,c}}{f}{_{1,1}}, 
    \leftidx{^c}{f}{^\tau_{1,1}}, \leftidx{^c}{f}{^\varepsilon_{1,1}}
    \right)$\\
\hline
Transition function &
    $\leftidx{^c}{c}{^{i+1}_1}\left[\leftidx{^B_{1..V}}{O}{_c}\right]
    :=\leftidx{^{c,c}}{f}{_{1,2}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right) \triangleq
    \mathcal{US}\left(\leftidx{^B_{1..V}}{O}{_p}, \leftidx{^B_K}{T} \cdot
    \leftidx{^K_{1..V}}{O}{_c}\right)$\\
\hline
Clarifications & \begin{tabular}{c p{0.5\linewidth}}
    $\leftidx{^B_{1..V}}{O}{_p}$ & Previously saved set of verified object
    hypotheses\\
    $\mathcal{US}$ & Update set function\\
    \end{tabular} \\
\end{tabular}
\caption{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,2}}$ general form and
    transition functions}
\label{table:B2}
\end{table}

\paragraph{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,3}}$} Generate the
\emph{pick} parameters: Select an object from the set of verified hypotheses
and estimate \emph{pick} and \emph{pre-pick} pose and the required gripper
aperture to grasp the object. This behaviour will terminate as soon as the
parameters are computed.

\begin{table}[H]
\centering
\begin{tabular}{rl}
General form & $\leftidx{^c}{\mathcal{B}}{_{1,3}} \triangleq 
    \leftidx{^c}{\mathcal{B}}{_{1,3}}\left(\leftidx{^{c,c}}{f}{_{1,3}}, 
    \leftidx{^c}{f}{^\tau_{1,3}}, \leftidx{^c}{f}{^\varepsilon_{1,3}}
    \right)$\\
\hline
Transition function & $\leftidx{^c}{c}{^{i+1}_1}
    :=\leftidx{^{c,c}}{f}{_{1,3}}\left(\leftidx{^c}{c}{^i_1}\right) \triangleq
    \begin{cases} 
        \leftidx{^{c,c}}{f}{_{1,3,1}}\left(\leftidx{^c}{c}{^i_1}\right) \\ 
        \leftidx{^{c,c}}{f}{_{1,3,2}}\left(\leftidx{^c}{c}{^i_1}\right) \\ 
        \leftidx{^{c,c}}{f}{_{1,3,3}}\left(\leftidx{^c}{c}{^i_1}\right) \\ 
        \leftidx{^{c,c}}{f}{_{1,3,4}}\left(\leftidx{^c}{c}{^i_1}\right) \\ 
    \end{cases}$ \\
Partial transition functions & $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_t}{O}{_c}]
    :=\leftidx{^{c,c}}{f}{_{1,3,1}}\left(\leftidx{^c}{c}{^i_1}\right)
    \triangleq \argmax\limits_{\leftidx{_v}{c}{_c}}
    \left(\leftidx{^B_{1..V}}{O}{_c}\right)$\\
 & $\leftidx{^c}{c}{^{i+1}_1}[d_o]
    :=\leftidx{^{c,c}}{f}{_{1,3,2}}\left(\leftidx{^c}{c}{^i_1}\right)
    \triangleq ||\mathcal{LR}\left(\argmax\limits_{\leftidx{_v}{c}{_c}}
    \left(\leftidx{^B_{1..V}}{O}{_c}\right)\right)||$\\
 & $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_{E_t}}{T}{_d}]
    :=\leftidx{^{c,c}}{f}{_{1,3,3}}\left(\leftidx{^c}{c}{^i_1}\right)
    \triangleq
    \mathcal{GC}\left(\mathcal{LR}\left(\argmax\limits_{\leftidx{_v}{c}{_c}}
    \left(\leftidx{^B_{1..V}}{O}{_c}\right)\right),\leftidx{^E_G}{T}\right)$\\
 & $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_{E_a}}{T}{_d}]
    :=\leftidx{^{c,c}}{f}{_{1,3,4}}\left(\leftidx{^c}{c}{^i_1}\right)
    \triangleq
    \mathcal{GC}\left(\mathcal{LR}\left(\argmax\limits_{\leftidx{_v}{c}{_c}}
    \left(\leftidx{^B_{1..V}}{O}{_c}\right)\right),\leftidx{^E_G}{T}\right)
    \cdot \leftidx{^A_T}{T}{^{-1}}$\\
\hline
Clarifications & \begin{tabular}{c p{0.5\linewidth}}
    $\argmax\limits_{\leftidx{_v}{c}{_c}}\left(\leftidx{^B_{1..V}}{O}{_c}\right)$ &
    Object in the set with maximum recognition confidence\\
    $\mathcal{LR}$ & Calculation of Left and Right grasp points on the object\\
    $\mathcal{GC}$ & Grasp-pose Calculation\\
    \end{tabular} \\
\end{tabular}
\caption{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,3}}$ general form and
    transition functions}
\label{table:B3}
\end{table}

\paragraph{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,4}}$} Move to the
\emph{pre-pick} location using \emph{Point To Point} motion while tracking the
target and correcting the \emph{pick} parameters. This behaviour terminates if
the system is deactivated (the STOP command is issued as described in
\autoref{itm:task-conditions}) or the end-effector is close enough to the
\emph{pre-pick} pose. The \emph{tolerance} that determines if the end-effector
is "close enough" to the \emph{pre-pick} pose should be tuned to not fall into
a situation where the behaviour never terminates. Due to the fact that the
\emph{pre-pick} pose is re-estimated while the manipulator is moving towards it
and therefore the exact pose might never be reached. In the case that the
system is deactivated during this stage, the system will fall back to move to
the initial position ($\leftidx{^c}{\mathcal{B}}{_{1,1}}$). Otherwise the
system will continue the \emph{pick} operation.

It can be argued that correcting the object pick gripper aperture $d_o$ might
be unnecessary at this stage. The object dimensions should not change with time
and therefore the corrections will be based on noise and object recognition
errors. But not updating the variable is subject to the same noise and object
recognition errors that might incur in a grip failure in the following stages.
Updating the pick gripper aperture $d_o$ reduces the risk of grip failure.

At this stage of the \emph{pick} phase, the gripper is not actuated, nor will
be in the next stage, therefore high frequency corrections do not have any
impact on the behaviour of the system. Nevertheless, the closer the manipulator
gets to the target object, the more likely is to have visual occlusion that
impedes updating the target object based on camera readings.

The decision about if this variable should be constantly updated, with a lower
frequency or not updated at all should be based on the computational power
available and the computation speed requirements. Which is out of the scope of
this project. It is assumed that the constant update has no negative impact on
the system performance and therefore used due to simplicity in the control
logic.

Error conditions are out of the project scope too, nevertheless it is worth to
mention that an extension of this system would take into account the situation
where the \emph{pick} pose is out of reach of the manipulator. It is a
situation that should be avoided by the Kinect virtual receptor, which verifies
that objects are within a bounding box known inside the manipulator workspace.
But in the case of a configuration mistake the situation error should be
handled too.

\begin{table}[H]
\centering
\begin{tabular}{rl}
General form & $\leftidx{^c}{\mathcal{B}}{_{1,4}} \triangleq
    \leftidx{^c}{\mathcal{B}}{_{1,4}}\left(\leftidx{^{c,c}}{f}{_{1,4}},
    \leftidx{^{c,e}}{f}{_{1,4}} \leftidx{^c}{f}{^\tau_{1,4}},
    \leftidx{^c}{f}{^\varepsilon_{1,4}} \right)$\\
\hline
Transition function & $\leftidx{^c}{c}{^{i+1}_1}
    :=\leftidx{^{c,c}}{f}{_{1,4}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right) \triangleq
    \begin{cases} 
        \leftidx{^{c,c}}{f}{_{1,4,1}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}\right) \\ 
        \leftidx{^{c,c}}{f}{_{1,4,2}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}\right) \\ 
        \leftidx{^{c,c}}{f}{_{1,4,3}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}\right) \\ 
        \leftidx{^{c,c}}{f}{_{1,4,4}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}\right) \\ 
    \end{cases}$ \\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[\leftidx{^B_E}{T}{_d}] :=
    \leftidx{^{c,e}}{f}{_{1,4}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right) \triangleq
    \mathcal{GC}\left(\mathcal{LR}\left(\mathcal{UT}\left(\leftidx{^B_t}{O}{_p},
    \leftidx{^B_K}{T} \cdot
    \leftidx{^K_{1..V}}{O}{_c}\right)\right),\leftidx{^E_G}{T}\right) \cdot
    \leftidx{^A_T}{T}{^{-1}} $\\
Partial transition functions &
    $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_t}{O}{_c}]
    :=\leftidx{^{c,c}}{f}{_{1,4,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right) \triangleq
    \mathcal{UT}\left(\leftidx{^B_t}{O}{_p}, \leftidx{^B_K}{T} \cdot
    \leftidx{^K_{1..V}}{O}{_c}\right)$\\
 & $\leftidx{^c}{c}{^{i+1}_1}[d_o]
    :=\leftidx{^{c,c}}{f}{_{1,4,2}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right) \triangleq
    ||\mathcal{LR}\left(\mathcal{UT}\left(\leftidx{^B_t}{O}{_p},
    \leftidx{^B_K}{T} \cdot \leftidx{^K_{1..V}}{O}{_c}\right)\right)||$\\
 & $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_{E_t}}{T}{_d}]
    :=\leftidx{^{c,c}}{f}{_{1,4,3}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right)
    \triangleq
    \mathcal{GC}\left(\mathcal{LR}\left(\mathcal{UT}\left(\leftidx{^B_t}{O}{_p},
    \leftidx{^B_K}{T} \cdot
    \leftidx{^K_{1..V}}{O}{_c}\right)\right),\leftidx{^E_G}{T}\right)$\\
 & $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_{E_a}}{T}{_d}]
    :=\leftidx{^{c,c}}{f}{_{1,4,4}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right)
    \triangleq
    \mathcal{GC}\left(\mathcal{LR}\left(\mathcal{UT}\left(\leftidx{^B_t}{O}{_p},
    \leftidx{^B_K}{T} \cdot
    \leftidx{^K_{1..V}}{O}{_c}\right)\right),\leftidx{^E_G}{T}\right) \cdot
    \leftidx{^A_T}{T}{^{-1}}$\\
\hline
Clarifications & \begin{tabular}{c p{0.5\linewidth}}
    $\mathcal{UT}$ & Update Target by matching it in a new set of verified
    object hypotheses from the Kinect sensor. If the target can't be found
    in the camera images (due to occlusion with the manipulator or any other
    reason), the new target position will be estimated using dead reckoning
    with the previous object position and instantaneous velocity\\
    $\leftidx{^B_t}{O}{_p}$ & Previously saved target object\\
    \end{tabular} \\
\end{tabular}
\caption{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,4}}$ general form and
    transition functions}
\label{table:B4}
\end{table}

\paragraph{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,5}}$} Move with force
control in the direction to the target while keeping the pose until the
estimated target position is reached or the end effector collides with the
target.

A velocity regulator $\mathcal{VR}$ is defined in \autoref{table:B5} as a
computation of the required end-effector velocity in order to reach a certain
relative velocity between two reference frames. The two reference frames are
the target object and the gripper center and in this situation it is desired to
make the gripper center approach the object with a constant relative speed,
independently of the movement of the target object.

It could be argued that if the manipulator moves fast enough this velocity
regulator would not be needed as the movement of the target could be neglected.
\autoref{itm:task-conditions} states that the maximum allowed target speed is
$5 cm/s$ and objects are cubes of side $3\pm0.5 cm$. With this in mind if the
manipulator moves from the \emph{pre-pick} pose $\leftidx{^B_{E_a}}{T}{_d}$ to
the \emph{pick} pose $\leftidx{^B_{E_t}}{T}{_d}$ $0.5$ the error could be as
big as the object. Not knowing the full specifications of the gripper and
manipulator this is an assumption that can't be made and therefore the designed
system must take into account the object movement when approaching the target.

\begin{table}[H]
\centering
\begin{tabular}{rl}
General form & $\leftidx{^c}{\mathcal{B}}{_{1,5}} \triangleq
    \leftidx{^c}{\mathcal{B}}{_{1,5}}\left(\leftidx{^{c,c}}{f}{_{1,5}},
    \leftidx{^{c,e}}{f}{_{1,5}} \leftidx{^c}{f}{^\tau_{1,5}},
    \leftidx{^c}{f}{^\varepsilon_{1,5}} \right)$\\
\hline
\begin{tabular}{c}Transition function\\(memory)\end{tabular} &
    $\leftidx{^c}{c}{^{i+1}_1}
    :=\leftidx{^{c,c}}{f}{_{1,5}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right) \triangleq
    \begin{cases} 
        \leftidx{^{c,c}}{f}{_{1,5,1}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}\right) \\ 
        \leftidx{^{c,c}}{f}{_{1,5,2}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}\right) \\ 
        \leftidx{^{c,c}}{f}{_{1,5,3}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}\right) \\ 
    \end{cases}$ \\
\begin{tabular}{c}Partial transition functions\end{tabular} &
    $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_t}{O}{_c}]
    :=\leftidx{^{c,c}}{f}{_{1,5,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right) \triangleq
    \mathcal{UT}\left(\leftidx{^B_t}{O}{_p}, \leftidx{^B_K}{T} \cdot
    \leftidx{^K_{1..V}}{O}{_c}\right)$\\
 & $\leftidx{^c}{c}{^{i+1}_1}[d_o]
    :=\leftidx{^{c,c}}{f}{_{1,5,2}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right) \triangleq
    ||\mathcal{LR}\left(\mathcal{UT}\left(\leftidx{^B_t}{O}{_p},
    \leftidx{^B_K}{T} \cdot \leftidx{^K_{1..V}}{O}{_c}\right)\right)||$\\
 & $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_{E_t}}{T}{_d}]
    :=\leftidx{^{c,c}}{f}{_{1,5,3}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right)
    \triangleq
    \mathcal{GC}\left(\mathcal{LR}\left(\mathcal{UT}\left(\leftidx{^B_t}{O}{_p},
    \leftidx{^B_K}{T} \cdot
    \leftidx{^K_{1..V}}{O}{_c}\right)\right),\leftidx{^E_G}{T}\right)$\\
\hline
\begin{tabular}{c}Transition function\\(manipulator effector)\end{tabular} &
    $\leftidx{^e_y}{c}{^{i+1}_{1,m}} :=
    \leftidx{^{c,e}}{f}{_{1,5}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq
    \begin{cases} 
        \leftidx{^{c,e}}{f}{_{1,5,1}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \\ 
        \leftidx{^{c,e}}{f}{_{1,5,2}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \\ 
        \leftidx{^{c,e}}{f}{_{1,5,3}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \\ 
        \leftidx{^{c,e}}{f}{_{1,5,4}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \\ 
        \leftidx{^{c,e}}{f}{_{1,5,5}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \\ 
    \end{cases}$\\
\begin{tabular}{c}Partial transition functions\end{tabular} &
    $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[b] :=
    \leftidx{^{c,e}}{f}{_{1,5,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq
    \left[\mathfrak{u},\mathfrak{u},\mathfrak{g},
    \mathfrak{u},\mathfrak{u},\mathfrak{u},\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[F_d] :=
    \leftidx{^{c,e}}{f}{_{1,5,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq 
    \left[-, -, -, -, -, -\right]$\\
 & $\begin{aligned}[t]\leftidx{^e_y}{c}{^{i+1}_{1,m}}[V_d] := &
    \leftidx{^{c,e}}{f}{_{1,5,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq \\
    & \mathcal{VR}\left(\leftidx{^B_E}{T}{_c},
    \mathcal{UT}\left(\leftidx{^B_t}{O}{_p}, \leftidx{^B_K}{T} \cdot
    \leftidx{^K_{1..V}}{O}{_c}\right), \leftidx{^E_G}{T}, \left[0, 0,
    \leftidx{_z}{V}{_d}, 0, 0, 0\right]\right)\end{aligned}$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[D_d] :=
    \leftidx{^{c,e}}{f}{_{1,5,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq 
    \left[-, -, \leftidx{_z}{D}{_d}, -, -, -\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[I_d] :=
    \leftidx{^{c,e}}{f}{_{1,5,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq 
    \left[-, -, \leftidx{_z}{I}{_d}, -, -, -\right]$\\
\hline
Clarifications & \begin{tabular}{c p{0.5\linewidth}} $\mathcal{VR}$ & Velocity
    Regulator. Gets as an input the current end-effector position, the current
    target object position and instantaneous velocity, the transformation from
    the end-effector reference frame to the center of the gripper and a 6
    element vector with the desired relative velocity between the center of the
    gripper and the target object w.r.t. the end-effector reference frame.
    Outputs a 6 element vector with the estimated end-effector required
    velocity in order to obtain the desired relative velocity between the
    center of the gripper and the target object\\ 
    \end{tabular} \\
\end{tabular}
\caption{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,5}}$ general form and
    transition functions}
\label{table:B5}
\end{table}

\paragraph{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,6}}$} Close the gripper
while moving with the target. An alternative would be to assume that the system
is able to close the gripper fast enough that the target object movement is
negligible. Due to the fact that the objects must move slowly in order to be
valid targets (\autoref{itm:task-goal}) this is a reasonable assumption.
Nevertheless we don't know the specifications of the gripper and therefore
can't assume that it will close fast enough. We must take into account the
movement of the target object while closing the gripper.

This behaviour terminates when the desired gripper aperture is reached or an
object is detected to be grasped.

\begin{table}[H]
\centering
\begin{tabular}{rl}
General form & $\leftidx{^c}{\mathcal{B}}{_{1,6}} \triangleq
    \leftidx{^c}{\mathcal{B}}{_{1,6}}\left(\leftidx{^{c,c}}{f}{_{1,6}},
    \leftidx{^{c,e}}{f}{_{1,6}} \leftidx{^c}{f}{^\tau_{1,6}},
    \leftidx{^c}{f}{^\varepsilon_{1,6}} \right)$\\
\hline
\begin{tabular}{c}Transition function\\(memory)\end{tabular} &
    $\leftidx{^c}{c}{^{i+1}_1}
    :=\leftidx{^{c,c}}{f}{_{1,6}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right) \triangleq
    \begin{cases} 
        \leftidx{^{c,c}}{f}{_{1,6,1}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}\right) \\ 
        \leftidx{^{c,c}}{f}{_{1,6,2}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}\right) \\ 
        \leftidx{^{c,c}}{f}{_{1,6,3}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}\right) \\ 
    \end{cases}$ \\
\begin{tabular}{c}Partial transition functions\end{tabular} &
    $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_t}{O}{_c}]
    :=\leftidx{^{c,c}}{f}{_{1,6,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right) \triangleq
    \mathcal{UT}\left(\leftidx{^B_t}{O}{_p}, \leftidx{^B_K}{T} \cdot
    \leftidx{^K_{1..V}}{O}{_c}\right)$\\
 & $\leftidx{^c}{c}{^{i+1}_1}[d_o]
    :=\leftidx{^{c,c}}{f}{_{1,6,2}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right) \triangleq
    ||\mathcal{LR}\left(\mathcal{UT}\left(\leftidx{^B_t}{O}{_p},
    \leftidx{^B_K}{T} \cdot \leftidx{^K_{1..V}}{O}{_c}\right)\right)||$\\
 & $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_{E_t}}{T}{_d}]
    :=\leftidx{^{c,c}}{f}{_{1,6,3}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}\right)
    \triangleq
    \mathcal{GC}\left(\mathcal{LR}\left(\mathcal{UT}\left(\leftidx{^B_t}{O}{_p},
    \leftidx{^B_K}{T} \cdot
    \leftidx{^K_{1..V}}{O}{_c}\right)\right),\leftidx{^E_G}{T}\right)$\\
\hline
\begin{tabular}{c}Transition function\\(effectors)\end{tabular} &
    $\left[\leftidx{^e_y}{c}{^{i+1}_{1,m}},
    \leftidx{^e_y}{c}{^{i+1}_{1,g}}\right] :=
    \leftidx{^{c,e}}{f}{_{1,6}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq
    \begin{cases} 
        \leftidx{^{c,e}}{f}{_{1,6,1}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \\ 
        \leftidx{^{c,e}}{f}{_{1,6,2}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \\ 
        \leftidx{^{c,e}}{f}{_{1,6,3}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \\ 
        \leftidx{^{c,e}}{f}{_{1,6,4}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \\ 
        \leftidx{^{c,e}}{f}{_{1,6,5}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \\ 
        \leftidx{^{c,e}}{f}{_{1,6,6}}\left(\leftidx{^c}{c}{^i_1},
        \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \\ 
    \end{cases}$\\
\begin{tabular}{c}Partial transition functions\end{tabular} &
    $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[b] :=
    \leftidx{^{c,e}}{f}{_{1,6,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq
    \left[\mathfrak{g},\mathfrak{g},\mathfrak{u},
    \mathfrak{u},\mathfrak{u},\mathfrak{u},\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[F_d] :=
    \leftidx{^{c,e}}{f}{_{1,6,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq 
    \left[-, -, -, -, -, -\right]$\\
 & $\begin{aligned}[t]\leftidx{^e_y}{c}{^{i+1}_{1,m}}[V_d] := &
    \leftidx{^{c,e}}{f}{_{1,6,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq \\
    & \mathcal{VR}\left(\leftidx{^B_E}{T}{_c},
    \mathcal{UT}\left(\leftidx{^B_t}{O}{_p}, \leftidx{^B_K}{T} \cdot
    \leftidx{^K_{1..V}}{O}{_c}\right), \leftidx{^E_G}{T}, \left[0, 0,
    0, 0, 0, 0\right]\right)\end{aligned}$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[D_d] :=
    \leftidx{^{c,e}}{f}{_{1,6,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq 
    \left[\leftidx{_x}{D}{_d}, \leftidx{_y}{D}{_d}, -, -, -, -\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[I_d] :=
    \leftidx{^{c,e}}{f}{_{1,6,1}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq 
    \left[\leftidx{_x}{I}{_d}, \leftidx{_y}{I}{_d}, -, -, -, -\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,g}}[d_d] :=
    \leftidx{^{c,e}}{f}{_{1,6,6}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^r_x}{c}{^i_{1,k}}, \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq
    d_o$\\
\end{tabular}
\caption{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,6}}$ general form and
    transition functions}
\label{table:B6}
\end{table}

\paragraph{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,7}}$} Generate the
\emph{post-pick} parameters, which is basically the \emph{post-pick} pose. This
must be above the actual pick position, not the estimated in
$\leftidx{^c}{\mathcal{B}}{_{1,3}}$ and therefore could not be computed with
the rest of \emph{pick} parameters. This behaviour terminates as soon as the
parameters are computed.

\begin{table}[H]
\centering
\begin{tabular}{rl}
General form & $\leftidx{^c}{\mathcal{B}}{_{1,7}} \triangleq 
    \leftidx{^c}{\mathcal{B}}{_{1,7}}\left(\leftidx{^{c,c}}{f}{_{1,7}}, 
    \leftidx{^c}{f}{^\tau_{1,7}}, \leftidx{^c}{f}{^\varepsilon_{1,7}}
    \right)$\\
\hline
Transition function & $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_{E_a}}{T}{_d}]
    :=\leftidx{^{c,c}}{f}{_{1,7}}\left(\leftidx{^c}{c}{^i_1},
    \leftidx{^e_x}{c}{^i_{1,m}}\right) \triangleq \leftidx{^B_E}{T}{_c} \cdot
    \leftidx{^A_T}{T}{^{-1}}$ \\
\end{tabular}
\caption{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,7}}$ general form and
    transition functions}
\label{table:B7}
\end{table}

\paragraph{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,8}}$} Retract from the
target pose $\leftidx{^B_{E_t}}{T}{_d}$ pose with position control. This is the
only behaviour that is used in two different states but in both cases it
terminates when the start approach pose (\emph{post-pick} or \emph{pre-place})
is reached. No contact or collision is expected while retracting, so the
movement is pure position control. 

The first state where this behaviour is used when retracting to the
\emph{post-pick} pose. Once the object is grasped the end-effector should
retract in trajectory similar to that of the approach. During the approach the
velocity regulator was needed in order to move with the target object but at
this stage the object is already grasped and the desired trajectory is simpler.
The end effector will move backwards in its $z$ direction. It is also used when
retracting to the \emph{pre-place} pose once the object has been released from
the gripper.

\begin{table}[H]
\centering
\begin{tabular}{rl}
General form & $\leftidx{^c}{\mathcal{B}}{_{1,8}} \triangleq
    \leftidx{^c}{\mathcal{B}}{_{1,8}}\left(\leftidx{^{c,e}}{f}{_{1,8}}
    \leftidx{^c}{f}{^\tau_{1,8}}, \leftidx{^c}{f}{^\varepsilon_{1,8}}
    \right)$\\
\hline
\begin{tabular}{c}Transition function\end{tabular} &
    $\leftidx{^e_y}{c}{^{i+1}_{1,m}}, :=
    \leftidx{^{c,e}}{f}{_{1,8}}\left(\leftidx{^c}{c}{^i_1} \right) \triangleq
    \begin{cases} 
        \leftidx{^{c,e}}{f}{_{1,8,1}}\left(\leftidx{^c}{c}{^i_1} \right) \\ 
        \leftidx{^{c,e}}{f}{_{1,8,2}}\left(\leftidx{^c}{c}{^i_1} \right) \\ 
        \leftidx{^{c,e}}{f}{_{1,8,3}}\left(\leftidx{^c}{c}{^i_1} \right) \\ 
        \leftidx{^{c,e}}{f}{_{1,8,4}}\left(\leftidx{^c}{c}{^i_1} \right) \\ 
        \leftidx{^{c,e}}{f}{_{1,8,5}}\left(\leftidx{^c}{c}{^i_1} \right) \\ 
    \end{cases}$\\
\begin{tabular}{c}Partial transition functions\end{tabular} &
    $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[b] :=
    \leftidx{^{c,e}}{f}{_{1,8,1}}\left(\leftidx{^c}{c}{^i_1} \right) \triangleq
    \left[\mathfrak{u},\mathfrak{u},\mathfrak{u},
    \mathfrak{u},\mathfrak{u},\mathfrak{u},\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[F_d] :=
    \leftidx{^{c,e}}{f}{_{1,8,1}}\left(\leftidx{^c}{c}{^i_1} \right) \triangleq
    \left[-, -, -, -, -, -\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[V_d] :=
    \leftidx{^{c,e}}{f}{_{1,8,1}}\left(\leftidx{^c}{c}{^i_1} \right) \triangleq
    \left[0, 0, \text{-}\leftidx{_z}{V}{_d}, 0, 0, 0\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[D_d] :=
    \leftidx{^{c,e}}{f}{_{1,8,1}}\left(\leftidx{^c}{c}{^i_1} \right) \triangleq
    \left[-, -, -, -, -, -\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[I_d] :=
    \leftidx{^{c,e}}{f}{_{1,8,1}}\left(\leftidx{^c}{c}{^i_1} \right) \triangleq
    \left[-, -, -, -, -, -\right]$\\
\end{tabular}
\caption{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,8}}$ general form and
    transition functions}
\label{table:B8}
\end{table}

\paragraph{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,9}}$} Generate the
\emph{place} parameters taking into account how many objects have been placed
in the palette so far and where should the next one be located with reference
to the palette reference frame. This behaviour terminates as soon as the
parameters are computed.

The proposed system generates the \emph{place} parameters based only on memory
data. But the structure can be expanded to admit commands from another agent
that can allow the coordination between several manipulators filling a single
palette.

\begin{table}[H]
\centering
\begin{tabular}{rl}
General form & $\leftidx{^c}{\mathcal{B}}{_{1,9}} \triangleq 
    \leftidx{^c}{\mathcal{B}}{_{1,9}}\left(\leftidx{^{c,c}}{f}{_{1,9}}, 
    \leftidx{^c}{f}{^\tau_{1,9}}, \leftidx{^c}{f}{^\varepsilon_{1,9}}
    \right)$\\
\hline
Transition function & $\leftidx{^c}{c}{^{i+1}_1}
    :=\leftidx{^{c,c}}{f}{_{1,9}}\left(\leftidx{^c}{c}{^i_1}\right) \triangleq
    \begin{cases} 
        \leftidx{^{c,c}}{f}{_{1,9,1}}\left(\leftidx{^c}{c}{^i_1}\right) \\ 
        \leftidx{^{c,c}}{f}{_{1,9,2}}\left(\leftidx{^c}{c}{^i_1}\right) \\ 
    \end{cases}$ \\
Partial transition functions &
    $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_{E_t}}{T}{_d}]
    :=\leftidx{^{c,c}}{f}{_{1,9,1}}\left(\leftidx{^c}{c}{^i_1}\right)
    \triangleq
    \mathcal{PC}\left(\leftidx{^B_P}{T},\leftidx{^E_G}{T}, n_o, p_x, p_y, n_x,
    n_y\right)$\\
 & $\leftidx{^c}{c}{^{i+1}_1}[\leftidx{^B_{E_a}}{T}{_d}]
    :=\leftidx{^{c,c}}{f}{_{1,9,2}}\left(\leftidx{^c}{c}{^i_1}\right)
    \triangleq
    \mathcal{PC}\left(\leftidx{^B_P}{T},\leftidx{^E_G}{T}, n_o, p_x, p_y, n_x,
    n_y\right) \cdot \leftidx{^A_T}{T}{^{-1}}$\\
\hline
Clarifications & \begin{tabular}{c p{0.5\linewidth}} $\mathcal{PC}$ & Palette
    place-pose Calculation. The pose where the object should be placed can be
    calculated from the palette position w.r.t. the base reference frame and
    the dimensions and object distribution in the palette\\
    \end{tabular} \\
\end{tabular}
\caption{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,9}}$ general form and
    transition functions}
\label{table:B9}
\end{table}

\paragraph{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,10}}$} Move to the
\emph{pre-place} position.

\begin{table}[H]
\centering
\begin{tabular}{rl}
General form & $\leftidx{^c}{\mathcal{B}}{_{1,10}} \triangleq 
    \leftidx{^c}{\mathcal{B}}{_{1,10}}\left(\leftidx{^{c,e}}{f}{_{1,10}}, 
    \leftidx{^c}{f}{^\tau_{1,10}}, \leftidx{^c}{f}{^\varepsilon_{1,10}}
    \right)$\\
\hline
Transition function & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[\leftidx{^B_E}{T}{_d}]
    :=\leftidx{^{c,e}}{f}{_{1,10}}\left(\leftidx{^c}{c}{^i_1}\right) \triangleq
    \leftidx{^B_{E_a}}{T}{_d}$ \\
\end{tabular}
\caption{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,10}}$ general form and
    transition functions}
\label{table:B10}
\end{table}

\paragraph{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,11}}$} Move to the place
position with force control until the position is reached or a collision with
the palette is detected.

\begin{table}[H]
\centering
\begin{tabular}{rl}
General form & $\leftidx{^c}{\mathcal{B}}{_{1,11}} \triangleq
    \leftidx{^c}{\mathcal{B}}{_{1,11}}\left(\leftidx{^{c,e}}{f}{_{1,11}}
    \leftidx{^c}{f}{^\tau_{1,11}}, \leftidx{^c}{f}{^\varepsilon_{1,11}}
    \right)$\\
\hline
\begin{tabular}{c}Transition function\end{tabular} &
    $\leftidx{^e_y}{c}{^{i+1}_{1,m}}, :=
    \leftidx{^{c,e}}{f}{_{1,11}}\left(\leftidx{^c}{c}{^i_1} \right) \triangleq
    \begin{cases} 
        \leftidx{^{c,e}}{f}{_{1,11,1}}\left(\leftidx{^c}{c}{^i_1} \right) \\ 
        \leftidx{^{c,e}}{f}{_{1,11,2}}\left(\leftidx{^c}{c}{^i_1} \right) \\ 
        \leftidx{^{c,e}}{f}{_{1,11,3}}\left(\leftidx{^c}{c}{^i_1} \right) \\ 
        \leftidx{^{c,e}}{f}{_{1,11,4}}\left(\leftidx{^c}{c}{^i_1} \right) \\ 
        \leftidx{^{c,e}}{f}{_{1,11,5}}\left(\leftidx{^c}{c}{^i_1} \right) \\ 
    \end{cases}$\\
\begin{tabular}{c}Partial transition functions\end{tabular} &
    $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[b] :=
    \leftidx{^{c,e}}{f}{_{1,11,1}}\left(\leftidx{^c}{c}{^i_1} \right)
    \triangleq \left[\mathfrak{u},\mathfrak{u},\mathfrak{g},
    \mathfrak{u},\mathfrak{u},\mathfrak{u},\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[F_d] :=
    \leftidx{^{c,e}}{f}{_{1,11,1}}\left(\leftidx{^c}{c}{^i_1} \right)
    \triangleq \left[-, -, -, -, -, -\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[V_d] :=
    \leftidx{^{c,e}}{f}{_{1,11,1}}\left(\leftidx{^c}{c}{^i_1} \right)
    \triangleq \left[0, 0, \leftidx{_z}{V}{_d}, 0, 0, 0\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[D_d] :=
    \leftidx{^{c,e}}{f}{_{1,5,1}}\left(\leftidx{^c}{c}{^i_1} \right) \triangleq
    \left[-, -, \leftidx{_z}{D}{_d}, -, -, -\right]$\\
 & $\leftidx{^e_y}{c}{^{i+1}_{1,m}}[I_d] :=
    \leftidx{^{c,e}}{f}{_{1,5,1}}\left(\leftidx{^c}{c}{^i_1} \right) \triangleq
    \left[-, -, \leftidx{_z}{I}{_d}, -, -, -\right]$\\
\end{tabular}
\caption{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,11}}$ general form and
    transition functions}
\label{table:B11}
\end{table}

\paragraph{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,12}}$} Drop the target by
opening the gripper. This behaviour terminates when the gripper aperture
reaches its maximum value.

\begin{table}[H]
\centering
\begin{tabular}{rl}
General form & $\leftidx{^c}{\mathcal{B}}{_{1,12}} \triangleq 
    \leftidx{^c}{\mathcal{B}}{_{1,12}}\left(\leftidx{^{c,e}}{f}{_{1,12}}, 
    \leftidx{^c}{f}{^\tau_{1,12}}, \leftidx{^c}{f}{^\varepsilon_{1,12}}
    \right)$\\
\hline
Transition function & $\leftidx{^e_y}{c}{^{i+1}_{1,g}}[d_d]
    :=\leftidx{^{c,e}}{f}{_{1,12}}\left(\leftidx{^c}{c}{^i_1}\right) \triangleq
    d_m$ \\
\end{tabular}
\caption{Behaviour $\leftidx{^c}{\mathcal{B}}{_{1,12}}$ general form and
    transition functions}
\label{table:B12}
\end{table}